ClientModule (Gradle API 2.14)
Date: 2016-06-14

Package: org.gradle.api.artifacts

## [Java] Interface ClientModule

- org.gradle.api.artifacts.ModuleVersionSelector

- All Superinterfaces:
    Dependency, ExternalModuleDependency, ExternalDependency, ModuleDependency, ModuleVersionSelector

  To model a module in your dependency declarations. Usually you can either declare a single dependency artifact or you declare a module dependency that depends on a module descriptor in a repository. With a client module you can declare a module dependency without the need of a module descriptor in a remote repository.

- - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `void` | `addDependency(ModuleDependency dependency)` Add a dependency to the client module.
    `ClientModule` | `copy()` {@inheritDoc}
    `Set<ModuleDependency>` | `getDependencies()` Returns all the dependencies added to the client module.
    `String` | `getId()` Returns the id of the client module.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `interface ExternalModuleDependency` | `copy, isChanging, setChanging`
    `interface ExternalDependency` | `copy, isForce, setForce`
    `interface ModuleDependency` | `addArtifact, artifact, copy, exclude, getArtifacts, getConfiguration, getExcludeRules, isTransitive, setTransitive`
    `interface ModuleVersionSelector` | `getGroup, getName, getVersion, matchesStrictly`

- - ### Method Detail

    - #### public void addDependency(ModuleDependency dependency)

      Add a dependency to the client module. Such a dependency is transitive dependency for the project that has a dependency on the client module.

      Parameters:
        `dependency` - The dependency to add to the client module.
      See Also:
        getDependencies()

    - #### public ClientModule copy()

      {@inheritDoc}

    - #### public Set<ModuleDependency> getDependencies()

      Returns all the dependencies added to the client module.

      See Also:
        addDependency(ModuleDependency)

    - #### public String getId()

      Returns the id of the client module. This is usually only used for internal handling of the client module.

      Returns:
        The id of the client module